.device ATtiny2313
.nolist
.include "C:\Program files\Atmel\AVR tools\AvrAssembler2\Appnotes\tn2313def.inc"
.list

.def temp 	= r16
.def temp1  = r17
.def Sek	= r18		;
.def desSek = r19		;
.def Min	= r20		;
.def DesMin = r21		;
.def Knopka_scet = r22

.equ RAM = $060					; 10 
.equ Displey_RAM = RAM + $10	;   
.equ EEPROM_RAM  = RAM + $20	;   
.equ EEPROM = $000				;   
.cseg
.org 0

rjmp Init
nop;.equ	INT0addr	= 0x0001	; External Interrupt Request 0
nop;.equ	INT1addr	= 0x0002	; External Interrupt Request 1
nop;.equ	ICP1addr	= 0x0003	; Timer/Counter1 Capture Event
reti;.equ	OC1Aaddr	= 0x0004	; Timer/Counter1 Compare Match A
rjmp Time;reti;.equ	OC1addr	= 0x0004	; For compatibility
rjmp Displey;.equ	OVF1addr	= 0x0005	; Timer/Counter1 Overflow
nop;rjmp Displey;;.equ	OVF0addr	= 0x0006	; Timer/Counter0 Overflow
nop;.equ	URXCaddr	= 0x0007	; USART, Rx Complete
nop;.equ	URXC0addr	= 0x0007	; For compatibility
nop;.equ	UDREaddr	= 0x0008	; USART Data Register Empty
nop;.equ	UDRE0addr	= 0x0008	; For compatibility
nop;.equ	UTXCaddr	= 0x0009	; USART, Tx Complete
nop;.equ	UTXC0addr	= 0x0009	; For compatibility
nop;.equ	ACIaddr	= 0x000a	; Analog Comparator
nop;.equ	PCIaddr	= 0x000b	; 
nop;.equ	OC1Baddr	= 0x000c	; 
nop;.equ	OC0Aaddr	= 0x000d	; 
nop;.equ	OC0Baddr	= 0x000e	; 
nop;.equ	USI_STARTaddr	= 0x000f	; USI Start Condition
nop;.equ	USI_OVFaddr	= 0x0010	; USI Overflow
nop;.equ	ERDYaddr	= 0x0011	; 
nop;.equ	WDTaddr	= 0x0012	; Watchdog Timer Overflow

;==========================================

;==============================================
;  
Time:
	ldi temp,low(49911)
	ldi temp1,high(49911)
	out TCNT1H,temp1
	out TCNT1L,temp
	ldi XL,Low(EEPROM_RAM)
	ldi XH,High(EEPROM_RAM)
	ld Sek,X+
	ld DesSek,X+
	ld Min,X+
	ld DesMin,X+

	cpi DesMin,0
	brne Dec_Sek
	cpi Min,0
	brne Dec_Sek
	cpi DesSek,0
	brne Dec_Sek
	cpi Sek,0
	brne Dec_Sek
	
	rjmp AND_Time	

Dec_Sek:
	dec sek
	cpi sek,255
	brne Time_1
	ldi sek,9

	dec DesSek
	cpi DesSek,255
	brne Time_1
	ldi DesSek,5

	dec Min
	cpi Min,255
	brne Time_1
	ldi Min,9
	dec DesMin
	
Time_1:
	st -X,DesMin
	st -X,Min
	st -X,DesSek
	st -X,Sek
reti
;===============================================
; 
Knopka_sbros:
reti
;===============================================
; 
;===============================================
Displey:
	ldi temp,5
	out TCNT0,temp

	brtc PC+2
	inc knopka_scet
	brts PC+2
	clr knopka_scet

	sbis PortD,3
	rjmp Sek_0
	sbis PortD,4
	rjmp DesSek_0
	sbis PortD,5
	rjmp Min_0
	sbis PortD,6
	rjmp DesMin_0
	cbi PortD,3
Displey_ON:
	ldi YL,low(RAM)
	ldi YH,High(RAM)
	cpi temp,0
	brne PC+2
	ldd temp1,Y + 0
	cpi temp,1
	brne PC+2
	ldd temp1,Y + 1
	cpi temp,2
	brne PC+2
	ldd temp1,Y + 2
	cpi temp,3
	brne PC+2
	ldd temp1,Y + 3
	cpi temp,4
	brne PC+2
	ldd temp1,Y + 4
	cpi temp,5
	brne PC+2
	ldd temp1,Y + 5
	cpi temp,6
	brne PC+2
	ldd temp1,Y + 6
	cpi temp,7
	brne PC+2
	ldd temp1,Y + 7
	cpi temp,8
	brne PC+2
	ldd temp1,Y + 8
	cpi temp,9
	brne PC+2
	ldd temp1,Y + 9

	out PortB,temp1
reti
;================================================
Sek_0:
	sbi PortD,3
	cbi PortD,4
	ldi ZL,low(EEPROM_RAM + 1)
	ld temp,Z
rjmp Displey_ON
DesSek_0:
	sbi PortD,4
	cbi PortD,5
	ldi ZL,low(EEPROM_RAM + 2)
	ld temp,Z

rjmp Displey_ON
Min_0:
	sbi PortD,5
	cbi PortD,6
	ldi ZL,low(EEPROM_RAM + 3)
	ld temp,Z

rjmp Displey_ON
DesMin_0:
	sbi PortD,6
	cbi PortD,3
	ldi ZL,low(EEPROM_RAM + 0)
	ld temp,Z

rjmp Displey_ON

;===============================================
;===============================================
;
Init:
	ldi temp,LOW(ramend)
	out SPL,temp

	ldi temp,0b11110000
	out DDRB,temp
	com temp
	out PortB,temp
;	out PinB,temp;-------------------------------;;;;;;;;;;;;;;;;;;
	ldi temp,0b01111101
	out DDRD,temp
	ldi temp,0b00111010
	out PortD,temp
	ser temp
	out DDRA,temp
	ldi YL,Low(RAM)
	ldi YH,High(RAM)

	ldi temp,0b00001111		;0
	st Y+,temp
	ldi temp,0b00011111		;1
	st Y+,temp
	ldi temp,0b10001111 	;2
	st Y+,temp
	ldi temp,0b10011111		;3
	st Y+,temp
	ldi temp,0b01001111		;4
	st Y+,temp
	ldi temp,0b01011111		;5
	st Y+,temp
	ldi temp,0b11001111		;6
	st Y+,temp
	ldi temp,0b11011111		;7
	st Y+,temp
	ldi temp,0b00101111		;8
	st Y+,temp
	ldi temp,0b00111111		;9
	st Y,temp

	ldi temp,0b00100000
	out MCUCR,temp

	in temp,TIMSK
	sbr temp,1<<TOIE0
	out TIMSK,temp
	ldi temp,5
	out TCNT0,temp
	ldi temp,3
	out TCCR0,temp

	ldi temp,0b10000000
	out SREG,temp

	rcall Init_EEPROM

	ldi XL,Low(EEPROM_RAM)
	ldi XH,High(EEPROM_RAM)
	clr temp1
	rcall Init_1
rjmp Start

Init_1:
	ld Sek,X+
	ld DesSek,X+
	ld Min,X+
	ld DesMin,X+
ret
;===============================================
;  
;  EEPROM
Init_EEPROM:
	ldi YL,Low(EEPROM)
	ldi YH,High(EEPROM)
	ldi XL,Low(EEPROM_RAM)
	ldi XH,High(EEPROM_RAM)
	clr temp1
Init_EEPROM_1:
	cli
	rcall EEPROM_read
	st X+,temp
	inc temp1
	cpi temp1,4
	breq PC+2
	rjmp Init_EEPROM_1
	sei
ret
EEPROM_read:
	sbic EECR,EEPE
	rjmp EEPROM_read
	out EEAR,YL
	sbi EECR,EERE
	ld temp,Y+
	in temp, EEDR
ret
;===============================================
;===============================================
;
AND_Time:
;	ldi temp,0b00000000
;	out TCCR1B,temp
	sbic PinD,2
	cbi PortD,2
	sbis PinD,2
	sbi PortD,2
reti
;===============================================
;===============================================
; 
Start:
	sbis PinB,3
	rcall Plus_Prog
;Plus_Prog_0:
	sbis PinB,2
	rcall Minus_prog
;Minus_prog_0:
	sbis PinB,0
	rcall BiziOFF_Start_Stop_Prog
;BiziOFF_Start_Stop_Prog_0:
	sbis PinB,1
	rcall Rec_prog
;Rec_prog_0:
;	sleep
	clt
	clr knopka_scet
rjmp start

;================================================
;  
;================================================
Minus_prog:
	sbic PinB,2
	ret
	set
	cpi knopka_scet,64
	brne Minus_Prog
	clr knopka_scet
	clt

	ldi XL,Low(EEPROM_RAM)
	ldi XH,High(EEPROM_RAM)
	ld Sek,X+
	ld DesSek,X+
	ld Min,X+
	ld DesMin,X+
Minus_prog_2:
	cpi Desmin,0
	brne Minus_prog_1
	cpi Min,0
	brne Minus_prog_1
;	cpi DesSek,0
;	brne Minus_prog_1
;	cpi Sek,0
;	brne Minus_prog_1
	ret
Minus_prog_1:
;	dec sek
;	cpi sek,255
;	brne Minus_prog_0
;	ldi sek,9
;	dec Dessek
;	cpi Dessek,255
;	brne Minus_prog_0
;	ldi Dessek,5
	dec Min
	cpi Min,255
	brne Minus_prog_0
	ldi Min,9
	dec DesMin
	cpi DesMin,255
	brne Minus_prog_0
	ldi DesMin,0
Minus_prog_0:
	st -X,DesMin
	st -X,Min
	st -X,DesSek
	st -X,Sek
ret
;================================================
;  
;================================================
Plus_Prog:
	sbic PinB,3
	ret
	set
	cpi knopka_scet,64
	brne Plus_Prog
	clr knopka_scet
	clt

	ldi XL,Low(EEPROM_RAM)
	ldi XH,High(EEPROM_RAM)
	ld Sek,X+
	ld DesSek,X+
	ld Min,X+
	ld DesMin,X+
Plus_prog_2:
	cpi Desmin,5
	brne Plus_prog_1
	cpi Min,9
	brne Plus_prog_1
;	cpi DesSek,5
;	brne Plus_prog_1
;	cpi Sek,9
;	brne Plus_prog_1
	ret
Plus_prog_1:
;	inc sek
;	cpi sek,10
;	brne Plus_prog_0
;	ldi sek,0
;	inc Dessek
;	cpi Dessek,6
;	brne Plus_prog_0
;	ldi Dessek,0
	inc Min
	cpi Min,10
	brne Plus_prog_0
	ldi Min,0
	inc DesMin
	cpi DesMin,6
	brne Plus_prog_0
	ldi DesMin,0
Plus_prog_0:
	st -X,DesMin
	st -X,Min
	st -X,DesSek
	st -X,Sek

ret
;================================================
;  . 
;================================================
BiziOFF_Start_Stop_Prog:	; 
	sbic PinB,0
	ret
	set
	cpi knopka_scet,64
	brne BiziOFF_Start_Stop_Prog
	clr knopka_scet
	clt
BiziOFF_Start_Stop_Prog_0:
	sbis PinB,0
	rjmp BiziOFF_Start_Stop_Prog_0
	set
	cpi knopka_scet,64
	brne BiziOFF_Start_Stop_Prog_0
	clr knopka_scet
	clt

BiziOFF_Start_Stop_Prog_1:
	in temp,TIMSK
	sbrc temp,7
	rjmp BiziOFF_Start_Stop_Prog_2
	ldi temp,low(49911)
	ldi temp1,high(49911)
	out TCNT1H,temp1
	out TCNT1L,temp
	in temp,TIMSK
	sbr temp,1<<7
	out TIMSK,temp
	ldi temp,0b00000100
	out TCCR1B,temp
ret
BiziOFF_Start_Stop_Prog_2:
	ldi temp,low(0)
	ldi temp1,high(0)
	out TCNT1H,temp1
	out TCNT1L,temp
	in temp,TIMSK
	cbr temp,1<<7
	out TIMSK,temp
	ldi temp,0b00000000
	out TCCR1B,temp
	cbi PortD,2
	rcall Init_EEPROM
ret
;================================================
; 
;================================================
Rec_prog:
;	sbic PinB,1
;	ret
	set
	cpi knopka_scet,64
	brne Rec_Prog
	clr knopka_scet
	clt
Rec_EEPROM:
	in temp,TIMSK
	sbrc temp,7
	ret
	cli
	ldi YL,Low(EEPROM)
	ldi YH,High(EEPROM)
	ldi XL,Low(EEPROM_RAM)
	ldi XH,High(EEPROM_RAM)
	clr temp1
Rec_EEPROM_1:
	rcall EEPROM_write
;	st Y+,temp
	inc temp1
	cpi temp1,4
	breq PC+2
	rjmp Rec_EEPROM_1
	sei
ret
EEPROM_write:
	sbic EECR,EEPE
	rjmp EEPROM_write
	ld temp,X+
	out EEAR,temp1
	out EEDR,temp
	sbi EECR,EEMPE
	sbi EECR,EEPE
ret
;================================================
; 
;================================================





